% DEMO good continuation demo file
%
% Requires the matlab_bgl toolbox:
% https://www.cs.purdue.edu/homes/dgleich/packages/matlab_bgl/
% It is included in the ZIP file but might require compilation

% IPOL SUBMISSION "An Unsupervised Algorithm for Detecting Good
% Continuation in Dot Patterns"
%
% Version 0.4, April 2017
%
% Copyright (c) 2017 Jose Lezama <jlezama@fing.edu.uy>
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU Affero General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
% GNU Affero General Public License for more details.
%
% You should have received a copy of the GNU Affero General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
clear
close all

addpath matlab_bgl/

%% load points
points = load('examples/spiral.txt');


% the points must be normalized to fall in [0, 1]x[0, 1]
if max(points(:))>1
    points = points/max(points(:));
end


%% set parameters
b = 5; % number of nearest neighbors to explore
lambda = 4; % ratio of size of the local window

%% run
tstart = tic;
[final_curves] = good_cont(points, b, lambda, '');
elapsed = toc(tstart);

fprintf('total time elapsed: %f\n', elapsed)
